/*  sstr.h  by K.Tsuru  */
// file ID = 60
#ifndef STRING_NUMBER_H
#define STRING_NUMBER_H
/********************
StringToNumber class
*********************/
class StringToNumber : public SNumber {
	char	*intPart;	//integer part
	uint    intLen;
	char    *decPart;	//decimal part
	uint    decLen;
	char    *expPart;
	uint    expLen;
	int     snRdxExp;	//exponent
	int 	snSign;		//sign
	void	GetDigit(const char* s);//eliminate iregal character and get "xxxPart" 601
	void 	Analyze();  		//602
	StringToNumber();						// cannot use
	StringToNumber(const StringToNumber& sn);	// cannot use
	StringToNumber& operator=(const StringToNumber& sn);// has no body.
public:
//It can use Sign(), Head() etc. of SNumber class.
	int	 RdxExp() const { return snRdxExp; }//not inclued in SNumber class
	StringToNumber(const char *s)
	: SNumber(UNKNOWN), intPart(NULL), intLen(0), decPart(NULL),
	  decLen(0), expPart(NULL), expLen(0), snRdxExp(0), snSign(UNDECIDED){
		GetDigit(s);	Analyze();
	}
	~StringToNumber();				// 603
};
#endif 		// STRING_NUMBER_H
