#!/bin/sh
#This is a script file to make executable file(s) in the "sn32/exeTDM64" directory on GNU/Linux.
#Please run in "/sn32/" directory. Wild card can be used.
if [ $# = 0 ]
then
echo "usage : $0 file..."
exit 1
fi

for file in $*
do
base=`echo $file | sed 's/\..*$//'`
echo $file
echo Making ./exeTDM64/${base}
#make obj file(s)
g++.exe -c $file -o lib/objTDM64/${base}.o  -I include -m64 -O3 -DNDEBUG=1 -Wall -Werror
#make exe file(s)
g++.exe lib/objTDM64/${base}.o -o exeTDM64/${base} -static-libgcc -s lib/TDMLib64.a
done
exit 0
