/*  combUL.cpp by K.Tsuru  */ 
/**************************************
It provides a binomial coefficient nCk
 ulong version. When n < 30 does not overflow.
**************************************/
#include "typedef.h"

ulong combUL(ulong n, ulong k) {
//	k = min(n, n - k);
	if(n < k) return 0;
	k = (n < n - k) ? n : n-k; // if n==k, k becomes 0.
	ulong r;
	if(k == 0) r = 1; // includes the case n == k
	else {
	 	r = combUL(n-1, k-1);
	 	r *=n;	r/= k;
	}
	return r;
}
