/*  scfplrbs.cpp  by K.Tsuru  */
// function ID = 9120
/***************************************
SComplex class
It returns r*{cos(x)+i*sin(x)}
using binary splitting.
*****************************************/
#ifndef SN_H
#include "sn.h"
#endif
SComplex CpolarBS(const SDouble& r, const SDouble& x){
	SDouble c, s;
	CosSinBS(x, c, s);
	return SComplex(r * c, r * s);
}
