/*  sdcrln10.cpp  by K.Tsuru  */
// function ID 3551  DARDIX		constant
/*********************
SDouble class
1/log(10)
**********************/
#ifndef SN_H
#include "sn.h"
#endif

static SDouble* recln10 = NULL;
static uint recln10Size = 0;

void recLog10Free(){		//free the memory of recln10
	if(recln10Size == 0) return;
	delete recln10;		recln10 = NULL;		recln10Size = 0;
}

SDouble RecLog10(){
	uint ms = SNManager::SNMaxSize(SNManager::REAL);
	if( recln10Size <  ms ){
		delete recln10;
		recln10 = new SDouble;

		SDouble x;
		x = Log10();
		*recln10 = DReciprocal(x);
		recln10Size = ms;
	}
	return *recln10;
}
