/*  sdmmprdx.cpp  by K.Tsuru  */
// function ID = 340  DRADIX, BRADIX
/********************************************
SDouble and SDecimal classes
a member function
It multiplies by the radix to the n-th power.
*********************************************/
#ifndef SN_H
#include "sn.h"
#endif
SDouble& SDouble::MultPowRdx(int n){
	if(!n || !SNSign()) return *this;	//does not use Sign()
	if(Type() == REAL){
//cout << " n = " << n << endl;
		SetRdxExp(rdxExp + n);
//cout << "after SetRdxExp() " << rdxExp + n <<endl;
		Reform(340);//In the fixed point mode the moving of figures is done.
	} else{	// Type() == BIN_DEC
		if((int)aTail - n < 0) SetError(OVERFLOW_ERR, "MultPowRdx", 340);
		ShiftArray(-n);//moving figures
	}
	return *this;
}
