/*  sdfeform.cpp  by K.Tsuru  */
// function ID 3404		DRADIX
/*******************************
SDouble class
It converts SDouble x to m*10^e (|m| < 1.0)
********************************/
#ifndef SN_H
#include "sn.h"
#endif

SDouble SDtoE_Form(const SDouble& x, long* exp){
	SDouble X(x); // copy
	//exponent portion
	long e = X.DExp();
	*exp = e;
	//mantissa : Its absolute value is less than 1.0.
	return X.MultPow10(-e);
}
