/*  sioidvdb.cpp  by K.Tsuru  */
// function ID = 405	BRADIX
/***********************************************
SInteger class
It divides "m" by double "d".
When "d" is small integer in a large roop
please use IsDiv().
***********************************************/
#ifndef SN_H
#include "sn.h"
#endif
SInteger operator/(const SInteger& m, double d){
	if(d == 0.0) m.SetError(m.DIVIDED_BY_ZERO,"SI /", 405);

	SInteger r;
	if(fabs(d) <= (double)m.SlOpMaxValue() ){
		ulong p = (ulong)fabs(d);
		IsDiv(m, p, r);
		if(d < 0) r.ChangeSign();
	} else {
		r = d;
		r = m/r;
	}
	return r;
}
