/*  siomuldb.cpp  by K.Tsuru  */
// function ID = 445	BRADIX
/***********************************
SInteger class
m*n including the case int,long, etc.
It converts "n" to an integer.
************************************/
#ifndef SN_H
#include "sn.h"
#endif
SInteger operator*(const SInteger& m, double n){
	if(n == 1.0)  return m;
	if(n == -1.0) return -m;
	if(n == 0.0) return SLong(m.Type(), minArraySize);

	SInteger r;
	if(fabs(n) <= (double)m.SlOpMaxValue() ){
		ulong p = (ulong)fabs(n);
		IsMult(m, p, r);
		if(n < 0) r.ChangeSign();
	} else {
		r = n;
		r = LLMult(m, r);
	}
	return r;
}
