/*  sioshftr.cpp  by K.Tsuru  */
// function ID = 411	BRADIX
/************************************************
SInteger class
It provides the bit shift operation to the right,ie
divides by 2^n.
************************************************/
#ifndef SN_H
#include "sn.h"
#endif

SInteger operator>>(const SInteger& m, ulong n){
	if(!n || (m.Sign(411) == 0)) return m;
	SInteger result(m);
	result.BitShift(-(long)n);
	return result;
}
