/*  siostrm.cpp  by K.Tsuru  */
// function ID = 430 BRADIX
/*********************************
SInteger class
 output stream
 It outputs in the four hexadecimal figures
 with radix = BRADIX = 2^15.
 The maximum vakue of figure is "7fff".
**********************************/
#ifndef SN_H
#include "sn.h"
#endif
ostream& operator<<(ostream& os, const SInteger& m) {
	int i = m.Head();
//cout <<"in << SInteger" << endl; getchar();
	int dm = m.delmt;
	os << std::hex << m(i);	 os.put(dm);	i--;
	for(; i>= 0; i-- ){
		os << std::hex << std::setw(4)<< std::setfill('0') << m(i);
		if(i) os.put(dm);
//cout << "m(" << i << ")=" << m(i) << endl;
	}
	os << endl;
	return os;
}

