/*  slodbrem.cpp  by K.Tsuru  */
// function ID = 211	DRADIX
/***************
SLong class
operator%() m%d
****************/
#ifndef SN_H
#include "sn.h"
#endif
SLong operator%(const SLong& m, double n){
	if(fabs(n) == 1.0) return SLong(m.Type(), minArraySize);// return 0.0;
	if( fabs(n) <= m.SlOpMaxValue() ){
		ulong p = (ulong)fabs(n);
		long rem;
		SLong result(m.Type(), 0);
		LsDiv(m, p, &rem);
		result = m.Sign(211)*labs(rem);
		return result;
	}
	return LLDiv(m, n, 1).rem;
}
