/*  sroequal.cpp  by K.Tsuru  */
// function ID = 8003	BRADIX
/*********************
SRational class
relational operator==
*********************/
#ifndef SN_H
#include "sn.h"
#endif
int operator==(const SRational& m, const SRational& n){
	if(m.Sign(7003) != n.Sign(7003)) return 0;
	if(m.ReduceDone() && n.ReduceDone()){	//Both are irreducible fractions.
		SLong t;
		if(LLCompare(m.NumNR(), n.NumNR())) return 0;	//numerator is diffrent
		if(LLCompare(m.DenNR(), n.DenNR())) return 0;   //denominator is different
		return 1;
	}
	if( RRCompare(m, n) ) return 0;
	return 1;
}
