#include <quadmath.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
using namespace std;

int main() {
    __float128 a = 1.0q, b = 1.0q / sqrtq(2.0q), t = 1.0q / 4, x = 1.0q, an, p; 
    int width = 46;
    char buf[128];
    int n;
	cout << "FLT128_DIG =" << FLT128_DIG << endl;
	cout << "FLT128_MANT_DIG =" << FLT128_MANT_DIG << endl;
    for (n = 1; n <= 5; n++) {
        an = (a + b) / 2.0q;
        b = sqrtq(a * b);
        t -= x * (an - a) * (an - a);
        x *= 2.0q;
        a = an;
        p = (a + b) * (a + b) / (4.0q * t);
        printf("%2d ", n);
        int k = quadmath_snprintf(buf, sizeof buf, "%+-#*.45Qe", width, p);
        if ((size_t)k < sizeof buf) printf ("%s\n", buf);
        printf("    3.14159265358979323846264338327950288\n");
    }
}
