/*  bsetest.cpp  by K.Tsuru  */ 
static const char* title =
"<<<<<<< Evaluation of e by binary splitting algorithm. >>>>>>>>";
#include "sn.h"
int main(){
	ErrorPuts(title);
	RealSize C;
	uint fig;
	double tBSE, tBE, tRecE;
	Timer timer;
	ErrorPut("Effective figures/4 = ");
	fig = GetInt();
	C.SetEffFig(fig, C.PROPER|C.TEMP_EXTEND);
	SDouble e,re, ef, dif;
	printf("Effective figures = %u\n", DFIGURES*e.EffFig());
// binary splitting algorithm
	timer.Start();
	ErrorPuts("Evaluating e by BSE().");
	e = BSE();
//	e = E();
	tBSE = timer.Stop();
	printf("cpu time = %8.3f(sec)(Binary Splitting method E()), %ld digits\n", tBSE, e.DFigures());
	ErrorPut("Do you output the result ? (yes(1)/no(0)) ");
	if(GetInt()){
		int format = e.CRLF | e.INT_PUT | e.SHOW_FIG;
		e.Puts(10,0,5,format);
		printf("cpu time = %8.3f(Binary Splitting method)\n", tBSE);
	}
	e.OutPutFile("bseSD.snc", 1);
	char buff[200];
	sprintf(buff,"Total digits = %lu.\n\n", e.DFigures());
	e.FPuts(buff);			e.Puts(10, 0, 5, e.CRLF | e.INT_PUT);
	e.OutPutFile(NULL);

	ErrorPut("Do you compare with SBE().Maybe it takes much time ? (yes(1)/no(0))");
	int gi = GetInt();
	if(gi){
    	ErrorPuts("Evaluating e by SBE().");
    	timer.Start();
    	ef = SC_ConvSDecToSDbl(BE());
    //	ef = BE().ConvToDec();
    	tBE = timer.Stop();
		setprecision(5);
    	cout << "cpu time = " << tBE << "(sec)" << endl;
    	dif = e-ef;
    
    	ErrorPut("very close to 0.0 ? ==>  ");	dif.Puts();
    	printf("Effective figures = %u\n", DFIGURES*e.EffFig());
    	printf("cpu time = %8.3f(Binary Splitting method), %8.3f(SNC)\n", tBSE, tBE);
    }

   	ErrorPuts("Evaluating 1/e by RecE().");
	timer.Start();
	re = RecE();
	tRecE = timer.Stop();
printf("cpu time = %8.3f(Binary Splitting method RecE() = 1/e ), %ld digits\n", tRecE, re.DFigures());

 e = (e*re)-1.0;
cout << "e*(1/e)-1 = " << e << " <== 0.0?" << endl;
	Ending();

	return EXIT_SUCCESS;
}
