/* istreamTest.cpp by K. Tsuru */
//test program for istream

#include "sn.h"

// output SInteger in hex.
void RawPuts(const SInteger& a, int rdx) {
	int i = a.Size();
cout << "i = " << i << endl;
	for(;i;i--){
		printf("%04d ", a(i));
	}
	putchar('\n');
}
void SIntTest(){
	SInteger x(2);

	x <<= 100;  // x = 2*2^100
//	cout << pow(2, 15) << endl;
	cout << "x in BRADIX = " << BRADIX <<  " =2^15)" << endl;
	cout << "x=" << x << endl;
	SLong k = x.ConvToDec();
	k.Puts(); // in DRADIX
	cout << "(x in DRADIX) k=" << k;
	cout << " same above ?" << endl;

	k--;
	x--;
k.Puts();
cout << "(x-- in BRADIX) x=" << x;
	x.SetFormat(4);	// Use SLong class's
	x.Puts();
cout << "x.RawPuts()"<< endl; x.RawPuts();
	x--;
cout << "BRADIX= " << BRADIX << "(dec), " << std::hex << 2*BRADIX << "(hex)\n";	
	int i;
	for(i = x.Head(); i; i-- ){
		cout << std::hex << x(i) << ' ';	
	}
	cout << endl;
	cout << (SInteger)x;
x = LRand(64, BRADIX);	
cout << x;
	Wait("---SIntTest() end.---");
}
void ScTest(){
	SComplex x(Sqrt(2.0),-Sqrt(3.0));
	x.SetFormat(x.MID_CR|x.END_CR|x.iFMT);
//cout<< "x.crLF= " << x.crLF << endl;
//	x.Puts(x.endCR|x.midCR,x.iFMT);
	cout << x;
	x.SetFormat(x.END_CR|x.BracketFMT);
	SComplex y(sqrt(2.0),-sqrt(3.0));
//	y.SetFormat(x.endCR,x.BracketFMT);
cout << "x.BracketFMT= " <<  x.BracketFMT << endl;
//cout << "x.crLF = " <<  x.crLF << endl;
//	y.Puts();
	cout << y;
	x = SetComplex("3.145e-3, -2.23698e2");
	cout << x;	
	y = SetComplex("(3.145e-3, -2.23698e2)");
	y.Puts();
	cout << "complex x = ?";
	cin >> x;
	cout <<"x =" << x << endl; 
	Wait("---ScTest() end.---");
}
void ShowFormat(const SDouble& x, int no){
//	static long ioCount;	// the number of input or output characters
//	static long figUnit, putFig, figCount;
//	static int perLine, lineFormat, delmt;
//	enum { NO_CR = 0, CRLF = 1, CONTINUE = 2, END_CR =4 , ROUND = 8,
//		INT_PUT = 16, SHOW_FIG = 32};
	cout << "No. (" << no << ")"<< endl;
//cout << "ioCount=" << x.ioCount<< " ,figUnit=" << x.figUnit <<" ,perLine=" <<
//	 x.perLine << " ,lineFormat="<< x.lineFormat << " ,delmt=|" << (char)x.delmt << '|' << endl;

}
void SdTest(){

	SDouble pi = Pi(), x(1240.0), y;

	cout << "y = ?";
	cin >> y;
	cout << endl << "y= " << y << endl;
	
	x.SetFormat(10,0,0,x.CRLF|x.ROUND|x.INT_PUT|x.SHOW_FIG);
ShowFormat(x,1);
	cout << x << endl;
ShowFormat(x,2);
	x.Puts();
	pi.SetFormat(10,0,0,x.CRLF|x.ROUND|x.INT_PUT|x.SHOW_FIG);
ShowFormat(pi,3);
	x.SetFormat(10,0,0,x.CRLF|x.ROUND|x.INT_PUT|x.SHOW_FIG);
ShowFormat(x,4);
	cout << pi << endl;
ShowFormat(x,5);
//	cin >> x;
	pi.Puts(10,0,0,x.CRLF|x.ROUND|x.INT_PUT|x.SHOW_FIG);
ShowFormat(x,6);
	Wait();
}
int main(){
	SdTest();
	SIntTest();
	ScTest();

	SLong a;

	a.SetFormat(10);
	cout << "a = ?";
	cin >> a;
	cout << endl << "a= " << a << endl;
//	a.Puts();
cout << a(0);
	Wait();

}
