/*  defconst.h  by K.Tsuru  */
/****************************************
SN library
Definition of Mathematical constants
Copy from "math.h" of Turbo C++ Ver. 4.0
*****************************************/
#ifndef  DEF_CONST_H
#define  DEF_CONST_H

/* Constants rounded for 21 decimals. */
#ifndef M_E
#define M_E         2.71828182845904523536
#endif
#ifndef M_LN10
#define M_LN10      2.30258509299404568402
#endif
#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif
#ifndef M_PI_2
#define M_PI_2      1.57079632679489661923
#endif
#ifndef M_PI_4
#define M_PI_4      0.785398163397448309616
#endif
#ifndef M_SQRT2
#define M_SQRT2     1.41421356237309504880
#endif
#ifndef M_SQRT_2
#define M_SQRT_2    0.707106781186547524401
#endif

#endif //DEF_CONST_H
