/*  rdxconv.cpp  by K.Tsuru  */
// since ver 2.18
/*****************************************
SNumber sub-function
It converts "long x" to "f[]" in radix R.
and returns "n".
x = f[n-1]*R^(n-1) + ... +f[1]*R + f[0]
*****************************************/
int rdxconv(int *f, long x, long R) {
	int i = 0;

	while(x) {
		f[i++] = x % R;	x /= R;
	}
	return i;
}
