/*  sdfatn2l.cpp  by K.Tsuru  */
// function ID 5105  DRADIX
/**************************************************************
SDouble class
inverse trigonometric function arctan(num/den) for num < den.
using SDecimal function in radix BRADIX
***************************************************************/
#ifndef SN_H
#include "sn.h"
#endif
SDouble Atan2L(ulong num, ulong den){
	SDecimal b;
	ulong mt = b.SlOpMaxValue();	// = 131071
	if( den > mt || !den || num >= den ) b.SetError(b.OUT_OF_RANGE,"Atan2L", 5105);

	b = Batan2(num, den);
	return b.ConvToDec();
}
