/*  sdfdfmod.cpp  by K.Tsuru  */
// function ID = 3009	DRADIX
/***********************************************************
 SDouble class
SDouble version of fmod
x = a*y + f ( a is an integral and |f| < |y|)
Return f, ipart=a.
If y==0 return zero and does not change the value of ipart.
***********************************************************/
#ifndef SN_H
#include "sn.h"
#endif

SDouble Fmod(const SDouble& x, const SDouble& y, SDouble& ipart){
	if(y.Sign(3009) == 0) return 0.0;

	Modf(x/y, ipart);	// x = a*y+f  a is integral
	return x - ipart*y;
}
