/*  sfmdnchk.cpp  by K.Tsuru  */
// function ID = 71  DRADIX
/**************************************************
SFraction class
It checks that the denominator is positive or not.
***************************************************/
#ifndef SN_H
#include "sn.h"
#endif
void SFraction::DenCheck(){
	if(den.Sign(71) == 0 ) den.SetError(den.DIVIDED_BY_ZERO,"SF", 71);
	if(den.Sign() < 0){
		den.ChangeSign();	// den = -den
		num.ChangeSign();	// num = -num
	}
	if(den.IsOne()) reduceDone = true;
}
