/*  sifipow.cpp  by K.Tsuru  */
// function ID 4106   BRADIX
/**************************************************************
SInteger classes
It provides to the n-th powewr of x(x^n) Knuth's binary method.
It provides to avoid an error in the statement such as
  SInteger a(10), r;
  r=LPow(a, 200) -1;
Because "operator-()" of SLong class is called and it interprets
as "SInteger - SLong" operation.
If it splits two statements
  r = LPow(a, 200);
  r -= 1;
no error causes.
***************************************************************/
#ifndef SN_H
#include "sn.h"
#endif
SInteger Ipow(const SInteger& x, ulong n){
	SInteger r;
	r = Lpow(x, n);	//Type (radix) of "r" is the same as that of "x".
	return r;
}
