/*  srfrsmul.cpp  by K.Tsuru  */
// function ID = 814  BRADIX
/*******************************
SRational class
operator x*n = x.num*n/x.den
********************************/
#ifndef SN_H
#include "sn.h"
#endif

SRational RsMult(const SRational& x, ulong n){
	if(n == 1UL) return x;
	if(!n) return 0.0;

	SRational r(x);
	if(n <= r.num.SlOpMaxValue()) IsMult(r.num, n, r.num);
	else						  r.num *= n;
    r.reduceDone = false;
	r.reduce(false);
	return r;
}
