/*  sxckspi.cpp  by K.Tsuru  */
// function ID 5107	  BRADIX
/********************************************************
pi by Klingenstierna's formura
pi/4 = 8*arctan(1/10) - arctan(1/239) -4*arctan(1/515)
*********************************************************/
#ifndef SN_H
#include "sn.h"
#endif
SDecimal BKlingenstiernaPi(){
	SDecimal bpi, u;

	bpi = Batan2(1, 10);
	XsMult(bpi, 8, bpi);
	u = Batan2(1, 239);
	XXSub(bpi, u, bpi);
	u = Batan2(1, 515);
	XsMult(u, 4, u);
	XXSub(bpi, u, bpi);
	XsMult(bpi, 4, bpi);
	return bpi;
}
// function ID 3510   DRADIX
SDouble KlingenstiernaPi(){
	return BKlingenstiernaPi().ConvToDec();
}
