/*  LDivPow2Test.cpp by K.Tsuru  */
//
// SInteger and SLong sample program
//
/*
friend long LDivPow2(const SLong& m, SLong& q, uint p);        // 236

It divides m by the p-th power of two, i.e. q=m/(2^p),
where 2^p < ULONG_MAX/radix. It returns the remainder.
Comparing a statement
	q = LsDiv(m, 1uL << p);
it is faster a few times. It is used in ReduceByPow2Rdx(), etc.
*/

const char* title = "<<<<<< q = m/(2^p) calculation >>>>>>";

#include "sn.h"

void Test01(){
	SLong m, n;
	long r, p = 15L, d = 1L << p;
	m = LRand(30u);
	r = LDivPow2(m, n, p);
	cout << "m = " << m << endl;
	cout << "divisor = 2^" << p << " = " << d << endl;
	cout << "n = m /" << d << "=" << n << endl;
	cout << "remainder =" << r << endl;
// m/d = n rem r. m= nd + r;
	SLong t= m - n*d -r;
	cout << t << " <-- 0?" << endl; 	
}
int main() {
	Test01();
	Ending();
}
