// SinCosTest2.cpp
#include "sn.h"

void CalcPi(int fig) {
// Dev-C++  .exe o͐ sn32/exe ɂĂƁB
// 萔t@C pi.snc Ȃbǂݍ܂ȂB
	RealSize C;
	Timer timer;
	C.SetEffFig(fig);
	timer.Start();
	Pi();
	double tPi = timer.Stop();
	printf("Pi() CPU time = %12.4f in fig = %d\n", tPi, fig);
}
void ShowCalcInfo(const SDouble& c, double cpu_time){
	printf("Up to %ldth terms, cpu time = %.3f\n",c.UpToTerm(), cpu_time);
}
void CompareSinValTest(const SDouble& x) {
	SDouble v[5], d;
	v[0] = Sin(x);
	v[1] = SinDiv(x);
	v[2] = SinBS(x);
	v[3] = SinRN(x);
	cout << "Sin(x)= " << v[0] << endl;
	int i;
	for(i=0; i<4 ; i++){	
		d= v[i]-v[0];	cout << "i= "<< i<< ":" <<d << endl;
	}
}
void FuncXTest(SDouble (*pfunc)(const SDouble&), const SDouble& x, const char* fname) {
	Timer timer;
	double cpu_time;
	SDouble r;
	int c = 100;

	fprintf(stderr, "Calculating %8s for x = %10.5f  %d times ", fname, doubleD(x), c);
	timer.Start();
	while(c--) r = (*pfunc)(x);
	cpu_time = timer.Stop();
	ShowCalcInfo(r, cpu_time);
}
void FuncSpeedTest(){
	RealSize C, D;
	SDouble x, rx, tx;
	uint ef;
	double d, pi4 = M_PI/4.0;
	ErrorPuts("Speed test for long decimal number.");
	while(1){
		ErrorPut("Effective figures /4 = ? ");
		ef = GetInt();
		if(!ef) break;
		C.SetEffFig(ef);
		x = DRand(0, DRADIX, 0);  d = doubleD(x);
		rx = 1.0/x;
		if(d > pi4) tx = x/pi4;
		else        tx = x;

		ErrorPuts("Calculating constants now.");
		D.SetEffFig(ef+10);
		E();	Log10();	Pi();   M2Pi();
		D.SetEffFig(0);
		printf("Figures of x = %u\n", x.Last());
		FuncXTest(SinRN, tx,"SinRN");
		FuncXTest(SinS_RN, tx,"SinS_RN");
		FuncXTest(SinDiv, tx,"SinDiv");
		FuncXTest(SinBS, tx,"SinBS");
		FuncXTest(CosRN, tx,"CosRN");
		FuncXTest(CosS_RN, tx,"CosS_RN");
		FuncXTest(CosDiv, tx,"CosDiv");
		FuncXTest(CosBS, tx,"CosBS");
		FuncXTest(Sin, tx,"Sin");
		FuncXTest(Cos, tx,"Cos");
		FuncXTest(Tan, tx,"Tan");
		FuncXTest(Exp, x,"Exp");
		FuncXTest(ExpBS, x,"ExpBS");
		FuncXTest(Log, x,"Log");
		FuncXTest(LogAGM, x,"LogAGM");
		FuncXTest(LogNW, x,"LogNW");
		FuncXTest(Sinh, x,"Sinh");
		FuncXTest(Cosh, x,"Cosh");
		FuncXTest(Tanh, x,"Tanh");
		FuncXTest(Asin, x,"Asin");
		FuncXTest(Acos, x,"Acos");
		FuncXTest(Atan, x,"Atan");
		FuncXTest(Asinh, x,"Asinh");
		FuncXTest(Acosh, rx,"Acosh");
		FuncXTest(Atanh, x,"Atanh");
		FuncXTest(Sqrt, x,"Sqrt");
		FuncXTest(DReciprocal, x,"DReciprocal");
		C.SetEffFig(0);
		Wait();
	}
}
/*
void ComapareSpeed(const SDouble& x) {
puts("*********** Compare Speed ****************");
while(1){
	ErrorPut("Effective figures/4 =? ");
	int fig = abs(GetInt());
	Timer timer;
	RealSize C;
CalcPi(fig);
	C.SetEffFig(fig);
SDouble X = x * Sqrt(2.0);
	printf("In ComapareSpeed() : X = "); X.Puts(5, 20);

	timer.Start();
	TrigFuncValues tv = CosSinBS(X);
	double tBS = timer.Stop();
	printf("sin(x) = ");	tv.sin.Puts(5,20);
	printf("cos(x) = ");	tv.cos.Puts(5,20);
	printf("BS method : upto %lu terms, CPU time = %12.4f\n", tv.sin.UpToTerm(), tBS);

	timer.Start();
	SDouble s, c, diff;
	s = Sin(X); c =Cos(X);
//	s = SinBS(X); c =CosBS(X);
	double tSC = timer.Stop();
	diff = (tv.sin - s) / s;
	printf("Sin(X) & Cos(X): CPU time = %12.4f\n", tSC);
	puts("( SinBS(X) - Sin(X) ) / Sin(x) =");
 	diff.Put(5, 20);	puts("<-- 0 ?\n");
	Wait();
	}
}
*/
int main() {
//SDouble	x = Pi() / 6;
CalcPi(10000);
SDouble x = Pi()/6;
	cout << "Sin(pi/6)= " << Sin(x) << endl;
Wait();
	CompareSinValTest(Pi()/6);
	FuncSpeedTest();
	Ending();
}
